variables:
  CARGO_TERM_COLOR: always
  DOCKER_FILE: $CI_PROJECT_DIR/Dockerfile
  DOCKER_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG

stages:
  - prepare
  - build
  - checks

default:
  before_script:
    - . ~/export-esp.sh
    - mv /ci-cache/target .

.legos-entity-job:
  image: ${DOCKER_IMAGE}
  needs: ["build-image"]
  parallel:
    matrix:
      - ENTITY:
        - legos
        - substation
        - prepare_static
        - house
        - branch_hv
        - branch_lv


# Stage: prepare
##############################################################################

build-image:
  before_script: []
  stage: prepare
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --file ${DOCKER_FILE} --tag ${DOCKER_IMAGE} --build-arg ci_project_dir=$CI_PROJECT_DIR .
    - docker push ${DOCKER_IMAGE}
  tags:
  - docker-image-builder

# Stage: build
##############################################################################

build-entities:
  stage: build
  extends: .legos-entity-job
  script:
    - cd $ENTITY
    - cargo build --release

# Stage: checks
##############################################################################

fmt:
  stage: checks
  image: ${DOCKER_IMAGE}
  script:
    - cargo fmt --all -- --check
  needs: ["build-image"]


clippy-entities:
  extends: .legos-entity-job
  stage: checks
  needs: ["build-image"]
  allow_failure: true
  script:
    - cd $ENTITY
    - cargo clippy --release -- -Dwarnings

pages:
  stage: checks
  needs: ["build-image"]
  image: ${DOCKER_IMAGE}
  script:
    - cargo doc --target=xtensa-esp32-none-elf -Z build-std=core --release --document-private-items
    - mv target/xtensa-esp32-none-elf/doc public
    - cp assets/legos_logo_simple.svg assets/favicon.ico assets/legos_logo.svg public
    - echo '<meta http-equiv="refresh" content="0; url=legos/index.html">' > public/index.html
  allow_failure: true
  artifacts:
    paths:
      - public
  only:
    - main
